﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace ComboDD
{
    public class ViewModel : NPCBase
    {
        public BindingList<OwnerInfo> DataSource { get; set; }

        public ViewModel()
        {
            DataSource = new BindingList<OwnerInfo>();
            DataSource.Add(new OwnerInfo()
            {
                Name = "Randy",
                Cars = new BindingList<CarInfo>()
                {
                    new CarInfo(){Brand="Chevy"},
                    new CarInfo(){Brand="Dodge"},
                    new CarInfo(){Brand="Jeep"},
                }
            });
             DataSource.Add(new OwnerInfo()
            {
                Name = "Sally",
                Cars = new BindingList<CarInfo>()
                {
                    new CarInfo(){Brand="Mercedes"},
                    new CarInfo(){Brand="Rolls Royce"},
                    new CarInfo(){Brand="BMW"},
                }
            });
             DataSource.Add(new OwnerInfo()
            {
                Name = "Bill",
                Cars = new BindingList<CarInfo>()
                {
                    new CarInfo(){Brand="Toyota"},
                    new CarInfo(){Brand="Honda"},
                    new CarInfo(){Brand="Ford"},
                    
                }
            });
        
        }

    }
    public class OwnerInfo : NPCBase
    {
        private string _name;
        public string Name
        {
            get { return _name; }
            set
            {
                if (_name != value)
                {
                    _name = value;
                    OnPropertyChanged("Name");
                }
            }
        }
        private BindingList<CarInfo> _cars;
        public BindingList<CarInfo> Cars
        {
            get { return _cars; }
            set
            {
                if (_cars != value)
                {
                    _cars = value;
                    OnPropertyChanged("Cars");
                }
            }
        }

      
    }

    public class CarInfo: NPCBase
    {
        private string _brand;
        private bool _own;


        public string Brand
        {
            get { return _brand; }
            set
            {
                if (_brand != value)
                {
                    _brand = value;
                    OnPropertyChanged("Brand");
                }
            }
        }

        //public bool IsOwned
        //{
        //    get { return _own; }
        //    set
        //    {
        //        if (_own != value)
        //        {
        //            _own = value;
        //            OnPropertyChanged("IsOwned");
        //        }
        //    }
        //}
    }

    

    public class NPCBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
